Draft PathArray: Difference between revisions

From FreeCAD Documentation
(Vertical GuiCommand, see also Draft PointArray)
(To position copies at specified points use Draft PointArray or Draft PointLinkArray)
(48 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>
<!--T:35-->
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}

<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand
|Name=Draft PathArray
|Name=Draft PathArray
|MenuLocation=DraftPathArray
|MenuLocation=ModificationArray tools → Path Array
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|SeeAlso=[[Draft_OrthoArray|Draft OrthoArray]], [[Draft_PolarArray|Draft PolarArray]], [[Draft_CircularArray|Draft CircularArray]], [[Draft_PathLinkArray|Draft PathLinkArray]], [[Draft_PointArray|Draft PointArray]], [[Draft_Clone|Draft Clone]]
|SeeAlso=[[Draft Array|Draft Array]], [[Draft PointArray]]
|Version=0.14
}}
}}


Line 12: Line 16:


<!--T:3-->
<!--T:3-->
The PathArray tool places copies of a selected shape along a selected path. The path can be a Wire or one or more Edges. The shapes can optionally be aligned with the tangent of the path. If required, a translation Vector can be specified to shift the shapes so the centroid is on the path. If no objects are selected, you will be invited to select them.
The {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft PathArray|Draft PathArray]]}} tool places copies of a selected shape along a selected path, which can be a [[Draft Wire|Draft Wire]], a [[Draft BSpline|Draft BSpline]], and similar edges.

<!--T:22-->
The PathArray tool can be used on any object that has a [[Part_TopoShape|Part TopoShape]], meaning 2D shapes created with the [[Draft_Workbench|Draft Workbench]], but also 3D solids created with other workbenches, for example, [[Part_Workbench|Part]], [[PartDesign_Workbench|PartDesign]], or [[Arch_Workbench|Arch]].

<!--T:23-->
* To create orthogonal, polar or circular arrays, use the corresponding {{Button|[[File:Draft_OrthoArray.svg|16px]] [[Draft_OrthoArray|OrthoArray]]}}, {{Button|[[File:Draft_PolarArray.svg|16px]] [[Draft_PolarArray|PolarArray]]}}, or {{Button|[[File:Draft_CircularArray.svg|16px]] [[Draft_CircularArray|CircularArray]]}} tools.
* To position [[App_Link|App Link]] copies along a path use {{Button|[[File:Draft_PathLinkArray.svg|16px]] [[Draft_PathLinkArray|PathLinkArray]]}}.
* To position copies at specified points use {{Button|[[File:Draft_PointArray.svg|16px]] [[Draft_PointArray|PointArray]]}} or {{Button|[[File:Draft_PointLinkArray.svg|16px]] [[Draft_PointLinkArray|PointLinkArray]]}}.
* To create copies and manually place them use {{Button|[[File:Draft_Move.svg|16px]] [[Draft_Move|Move]]}} or {{Button|[[File:Draft_Rotate.svg|16px]] [[Draft_Rotate|Rotate]]}}.
* To create exact copies and manually place or scale them, use {{Button|[[File:Draft_Clone.svg|16px]] [[Draft_Clone|Clone]]}} or {{Button|[[File:Std_LinkMake.svg|16px]] [[Std_LinkMake|Std LinkMake]]}}.


</translate>
</translate>
[[Image:Draft_PathArray_Example.png|400px]]
[[Image:Draft_PathArray_Example.png|400px]]
<translate>
<translate>
<!--T:24-->
{{Caption|Object arranged along a path}}


==How to use== <!--T:4-->
==Usage== <!--T:4-->


<!--T:5-->
<!--T:5-->
# Select the object that you wish to distribute.
# Create a shape object you wish to distribute. You will get the best results if your object is '''centred around the origin''', even if the path starts somewhere else.
# Select a path object along which the shapes will be distributed. -or-
# Select the path object or edges along which the object will be distributed.
# Press the {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft_PathArray|PathArray]]}} button.
# Select some edges of a path object.
# The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.
# Press the {{KEY|[[Image:Draft_PathArray.png|16px]] [[Draft PathArray]]}} button.

<!--T:25-->
Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

<!--T:26-->
{{Emphasis|Note:}} if the {{PropertyData|Base}} object doesn't seem to be positioned correctly in the path, check that its {{PropertyData|Placement}} is in the origin {{Value|(0,0,0)}}. Certain objects can be placed anywhere in the 3D space when used with the {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft_PathArray|PathArray]]}} tool, but others must be at the origin, particularly those created by using {{Button|[[File:Part_Extrude.svg|16px]] [[Part_Extrude|Part Extrude]]}} with a 2D profile like a {{Button|[[File:Sketcher_NewSketch.svg|16px]] [[Sketch|Sketch]]}}.


==Options== <!--T:6-->
==Options== <!--T:6-->


<!--T:7-->
<!--T:7-->
There are no options for this tool. Either it works with the selected objects or not.
* The array starts with shape copies which are not aligned to the path, nor translated to a new position by default. You can then change the count, alignment and/or translation vector in the properties.


==Properties== <!--T:8-->
==Properties== <!--T:8-->

<!--T:46-->
A [[Draft_PathArray|PathArray]] is derived from a [[Part_Feature|Part Feature]] ({{incode|Part::Feature}} class), therefore it shares all the latter's properties. In addition to the properties described in [[Part_Feature|Part Feature]], the PathArray has the following properties in the [[property_editor|property editor]].


<!--T:9-->
<!--T:9-->
{{TitleProperty|Alignment}}
* {{PropertyData|Base}}: The shape object
* {{PropertyData|Align|Bool}}: if it is {{TRUE}} the copies will be aligned to the path; otherwise they are left in their default orientation.
* {{PropertyData|PathObj}}: The path object
:{{Emphasis|Note:}} in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
* {{PropertyData|PathSubs}}: The subelements(edges) of path object to be used as the path
* {{PropertyData|Count}}: The number of time to copy the shape
* {{PropertyData|Align Mode|Enumeration}}: three modes, {{Value|Original}}, {{Value|Frenet}}, {{Value|Tangent}}.
* {{PropertyData|Extra Translation|VectorDistance}}: additional displacement vector {{Value|(x, y, z)}} that will be applied to each copy along the path. This is useful to make small adjustments in the position of the copies, for example, when its reference point doesn't match the center point of its shape.
* {{PropertyData|Xlate}}: The translation vector
* {{PropertyData|Force Vertical|Bool}}: if it is {{TRUE}}, the value of {{PropertyData|Vertical Vector}} will be used as the local Z direction, when {{PropertyData|Align Mode}} is {{Value|Original}} or {{Value|Tangent}}. {{Version|0.19}}
* {{PropertyData|Align}}: True to align the shapes to the path, False to leave shapes in their default orientation.
* {{PropertyData|Tangent Vector|Vector}}: it defaults to {{Value|(1, 0, 0)}}; alignment unit vector that will be used when {{PropertyData|Align Mode}} is {{Value|Tangent}}. {{Version|0.19}}
* {{PropertyData|Vertical Vector|Vector}}: it defaults to {{Value|(0, 0, 1)}}; unit vector of the local Z direction that will be used when {{PropertyData|Vertical Vector}} is {{TRUE}}. {{Version|0.19}}

<!--T:47-->
{{TitleProperty|Objects}}
* {{PropertyData|Base|LinkGlobal}}: specifies the object to duplicate in the path.
* {{PropertyData|Count|Integer}}: specifies the number of copies to create in the path.
* {{PropertyData|Path Object|LinkGlobal}}: specifies the object along which the copies will be distributed. It must contain {{Value|'Edges'}} in its [[Part_TopoShape|Part TopoShape]]; for example, it could be a {{Button|[[File:Draft_Wire.svg|16px]] [[Draft_Wire|Wire]]}} or {{Button|[[File:Draft_BSpline.svg|16px]] [[Draft_BSpline|BSpline]]}}.
* {{PropertyData|Path Subelements|LinkSubListGlobal}}: specifies the sub-elements (edges) of the {{PropertyData|Path Object}} on which the copies will be created. The copies will be created only on these edges. If this property is empty, the copies will be distributed on the entire {{PropertyData|Path Object}}.


==Scripting== <!--T:10-->
==Scripting== <!--T:10-->
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:11-->
<!--T:11-->
The PathArray tool can by used in [[macros]] and from the python console by using the following function:
The PathArray tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:


<!--T:48-->
Older call
</translate>
</translate>
{{Code|code=
{{Code|code=
makePathArray(shapeobject,pathobject,count,[translationvector],[alignment],[listofpathsubelements])
path_array = makePathArray(base_object, path_object, count, xlate=None, align=False, pathobjsubs=[])
}}
}}
<translate>
<translate>

<!--T:49-->
New call
</translate>
{{Code|code=
path_array = make_path_array(base_object, path_object,
count=4, extra=App.Vector(0, 0, 0), subelements=None,
align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
use_link=True):
}}
<translate>

<!--T:12-->
<!--T:12-->
* Creates a {{incode|"PathArray"}} object from the {{incode|base_object}}, by placing as many as {{incode|count}} copies along {{incode|path_object}}.
* Distribute count copies of a document shapeobject along a pathobject or subobjects of a pathobject. Optionally translates each copy by FreeCAD.Vector xlate direction and distance to adjust for difference in shape centre vs shape reference point. Optionally aligns baseobject to tangent/normal/binormal of path.
** Instead of a reference to an object, {{incode|base_object}} and {{incode|path_object}} can also be {{incode|Labels}} (strings) of objects existing in the current document.
** If {{incode|extra}} is given, it is a vector that displaces each of the individual copies by a small amount.
** If {{incode|subelements}} is given, it is a list of edges of {{incode|path_object}}, for example, {{incode|['Edge1', 'Edge2']}}; the copies will be created along this shorter path.
** If {{incode|align}} is {{incode|True}}, the copies are aligned along the {{incode|path_object}} depending on the value of {{incode|align_mode}}, which may be {{incode|"Original"}}, {{incode|"Frenet"}} or {{incode|"Tangent"}}.
** If {{incode|tan_vector}} is given, it is a unit vector that defines the local tangent direction of the copy along the path. It is used when {{incode|align_mode}} is {{incode|"Tangent"}}.
** If {{incode|force_vertical}} is {{incode|True}}, the value of {{incode|vertical_vector}} is used to determine the local Z direction of the copy along the path. It is used when {{incode|align_mode}} is {{incode|"Original"}} or {{incode|"Tangent"}}.
** If {{incode|use_link}} is {{incode|True}}, the type of array created will be a [[Draft_PathLinkArray|PathLinkArray]], whose elements are [[App_Link|App Link]] instances instead of simple copies.


<!--T:13-->
<!--T:13-->
Line 58: Line 115:
</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD,Draft
import FreeCAD as App
import Draft
Draft.makePathArray(base,path,items,centretrans,orient,pathsubs)
}}
<translate>


doc = App.newDocument()
==Usage Notes== <!--T:15-->
* Align + Xlate: When Align is True, the Xlate vector is relative to the local (tangent/normal/binormal) coordinates. When Align is False, the Xlate vector is relative to the global (XYZ) coordinates.


p1 = App.Vector(500, -1000, 0)
==Limitations== <!--T:14-->
p2 = App.Vector(1500, 1000, 0)
* This tool is not available before version 0.14
p3 = App.Vector(3000, 500, 0)
* The PathSubs Property does not yet appear in the properties list.
p4 = App.Vector(4500, 100, 0)
spline = Draft.make_bspline([p1, p2, p3, p4])
obj = Draft.make_polygon(3, 500)


path_array = Draft.make_path_array(obj, spline, 6)
==Technical Explanation== <!--T:16-->
doc.recompute()
When "Align = false", PathArray's logic is quite easy to understand.

wire = Draft.make_wire([p1, -p2, -p3, -p4])
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
doc.recompute()
}}
<translate>

==Technical explanation for the Align property== <!--T:16-->
When {{PropertyData|Align}} is {{FALSE}}, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.
</translate>
[[Image:patharray_NoAlign.png|600px|left|Align false]]
[[Image:patharray_NoAlign.png|600px|left|Align false]]
{{clear}}
{{clear}}
<translate>
<!--T:27-->
{{Caption|Object arranged along a closed path in the original orientation}}


<!--T:17-->
<!--T:17-->
When "Align = true" the logic is a bit harder to grasp:
When {{PropertyData|Align}} is {{TRUE}}, the positioning of the shapes becomes a bit more complex:
# Construct Frenet coordinate systems on the path (X is tangent, Z is normal, Y is binormal).
# First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
# Copy the original object to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
# Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
</translate>
[[Image:patharray alignment annotated.png|600px|left]]
[[Image:patharray alignment annotated.png|600px|left]]
{{clear}}
{{clear}}
<translate>
<!--T:28-->
{{Caption|Object arranged along a closed path; description of components and path}}


<!--T:18-->
<!--T:18-->
It is much easier to understand with pictures. The following images show how the array is produced, depending on which plane is the path.
The following images show how the array is produced, depending on which plane the path is.


<!--T:19-->
<!--T:19-->
Path on XY Plane:
[[Image:patharray_alignment.png|600px|left|XY Plane]]
</translate>
[[Image:patharray_alignment.png|600px|left]]
{{clear}}
{{clear}}
<translate>
Path on XY Plane
<!--T:29-->
<br />
{{Caption|Object arranged along a closed path which is aligned to the XY plane}}
[[Image:patharray_alignment-XZ.png|600px|left|XZ Plane]]

<!--T:30-->
Path on XZ Plane:
</translate>
[[Image:patharray_alignment-XZ.png|600px|left]]
{{clear}}
{{clear}}
<translate>
Path on XZ Plane
<!--T:31-->
<br />
{{Caption|Object arranged along a closed path which is aligned to the XZ plane}}
[[Image:patharray_alignment-YZ.png|600px|left|YZ Plane]]

<!--T:32-->
Path on YZ Plane:
</translate>
[[Image:patharray_alignment-YZ.png|600px|left]]
{{clear}}
{{clear}}
<translate>
Path on YZ Plane
<!--T:33-->
<br />
{{Caption|Object arranged along a closed path which is aligned to the YZ plane}}
{{clear}}


<!--T:20-->
<!--T:20-->
The clear advantage of this logic is that as you reorient the path but not the object, the result is consistent - object remains aligned to the path the way it was before reorienting the path.
As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.


<!--T:21-->
<!--T:21-->
(Thanks to @DeepSOIC for this explanation)
{{Emphasis|Editor:}} thank you to user DeepSOIC for this explanation.

==Additional alignment modes and options introduced in v0.19== <!--T:38-->

<!--T:39-->
'''Original''' mode (the default) is the historic alignment mode as in version 0.18.
It is not really the Frenet alignment. Original mode uses the normal parameter
from Draft.getNormal (or the default) as a constant - it does not calculate
curve normal. X follows the curve tangent, Y is the normal parameter, Z is
X.Cross(Y).

<!--T:40-->
'''Tangent''' mode is similar to '''Original''', but includes a rotation to align the
Base object's X to the TangentVector before placing copies. After the
rotation, Tangent behaves the same as Original. In previous versions this
rotation would be performed manually before invoking PathArray.

<!--T:41-->
'''Frenet''' mode orients the copies to a coordinate system along the path. X is
tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not
be computed (ex a straight line), the default is used.

<!--T:42-->
The ForceVertical option applies to Original and Tangent modes. When this
option is applied, the normal parameter from Draft.getNormal is ignored. X
follows the curve tangent, Z is the VerticalVector property and Y is
X.Cross(Z).

<!--T:43-->
Version 18 cycle chain - Original mode
[[Image:patharray_cycleChain.png|600px|left|Align false]]
{{clear}}

<!--T:44-->
Railway cross ties (sleepers) - Tangent mode + ForceVertical
[[Image:patharray_railwayTies.png|600px|left|Align false]]
{{clear}}

<!--T:45-->
Frenet Mode
[[Image:patharray_FrenetMode.png|600px|left|Align false]]
{{clear}}


<!--T:34-->
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}

</translate>
</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Revision as of 05:19, 24 August 2020

Draft PathArray

Menu location
Modification → Array tools → Path Array
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.14
See also
Draft OrthoArray, Draft PolarArray, Draft CircularArray, Draft PathLinkArray, Draft PointArray, Draft Clone

Description

The Draft PathArray tool places copies of a selected shape along a selected path, which can be a Draft Wire, a Draft BSpline, and similar edges.

The PathArray tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch.

Object arranged along a path

Usage

  1. Select the object that you wish to distribute.
  2. Select the path object or edges along which the object will be distributed.
  3. Press the PathArray button.
  4. The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

Note: if the DataBase object doesn't seem to be positioned correctly in the path, check that its DataPlacement is in the origin (0,0,0). Certain objects can be placed anywhere in the 3D space when used with the PathArray tool, but others must be at the origin, particularly those created by using Part Extrude with a 2D profile like a Sketch.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

A PathArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the PathArray has the following properties in the property editor.

Alignment

  • DataAlign (Bool): if it is true the copies will be aligned to the path; otherwise they are left in their default orientation.
Note: in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
  • DataAlign Mode (Enumeration): three modes, Original, Frenet, Tangent.
  • DataExtra Translation (VectorDistance): additional displacement vector (x, y, z) that will be applied to each copy along the path. This is useful to make small adjustments in the position of the copies, for example, when its reference point doesn't match the center point of its shape.
  • DataForce Vertical (Bool): if it is true, the value of DataVertical Vector will be used as the local Z direction, when DataAlign Mode is Original or Tangent. introduced in version 0.19
  • DataTangent Vector (Vector): it defaults to (1, 0, 0); alignment unit vector that will be used when DataAlign Mode is Tangent. introduced in version 0.19
  • DataVertical Vector (Vector): it defaults to (0, 0, 1); unit vector of the local Z direction that will be used when DataVertical Vector is true. introduced in version 0.19

Objects

  • DataBase (LinkGlobal): specifies the object to duplicate in the path.
  • DataCount (Integer): specifies the number of copies to create in the path.
  • DataPath Object (LinkGlobal): specifies the object along which the copies will be distributed. It must contain 'Edges' in its Part TopoShape; for example, it could be a Wire or BSpline.
  • DataPath Subelements (LinkSubListGlobal): specifies the sub-elements (edges) of the DataPath Object on which the copies will be created. The copies will be created only on these edges. If this property is empty, the copies will be distributed on the entire DataPath Object.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The PathArray tool can be used in macros and from the Python console by using the following function:

Older call

path_array = makePathArray(base_object, path_object, count, xlate=None, align=False, pathobjsubs=[])

New call

path_array = make_path_array(base_object, path_object,
                             count=4, extra=App.Vector(0, 0, 0), subelements=None,
                             align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
                             force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
                             use_link=True):
  • Creates a "PathArray" object from the base_object, by placing as many as count copies along path_object.
    • Instead of a reference to an object, base_object and path_object can also be Labels (strings) of objects existing in the current document.
    • If extra is given, it is a vector that displaces each of the individual copies by a small amount.
    • If subelements is given, it is a list of edges of path_object, for example, ['Edge1', 'Edge2']; the copies will be created along this shorter path.
    • If align is True, the copies are aligned along the path_object depending on the value of align_mode, which may be "Original", "Frenet" or "Tangent".
    • If tan_vector is given, it is a unit vector that defines the local tangent direction of the copy along the path. It is used when align_mode is "Tangent".
    • If force_vertical is True, the value of vertical_vector is used to determine the local Z direction of the copy along the path. It is used when align_mode is "Original" or "Tangent".
    • If use_link is True, the type of array created will be a PathLinkArray, whose elements are App Link instances instead of simple copies.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(500, -1000, 0)
p2 = App.Vector(1500, 1000, 0)
p3 = App.Vector(3000, 500, 0)
p4 = App.Vector(4500, 100, 0)
spline = Draft.make_bspline([p1, p2, p3, p4])
obj = Draft.make_polygon(3, 500)

path_array = Draft.make_path_array(obj, spline, 6)
doc.recompute()

wire = Draft.make_wire([p1, -p2, -p3, -p4])
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
doc.recompute()

Technical explanation for the Align property

When DataAlign is false, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.

Align false
Align false

Object arranged along a closed path in the original orientation

When DataAlign is true, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.

Object arranged along a closed path; description of components and path

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Object arranged along a closed path which is aligned to the XY plane

Path on XZ Plane:

Object arranged along a closed path which is aligned to the XZ plane

Path on YZ Plane:

Object arranged along a closed path which is aligned to the YZ plane

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.

Additional alignment modes and options introduced in v0.19

Original mode (the default) is the historic alignment mode as in version 0.18. It is not really the Frenet alignment. Original mode uses the normal parameter from Draft.getNormal (or the default) as a constant - it does not calculate curve normal. X follows the curve tangent, Y is the normal parameter, Z is X.Cross(Y).

Tangent mode is similar to Original, but includes a rotation to align the Base object's X to the TangentVector before placing copies. After the rotation, Tangent behaves the same as Original. In previous versions this rotation would be performed manually before invoking PathArray.

Frenet mode orients the copies to a coordinate system along the path. X is tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not be computed (ex a straight line), the default is used.

The ForceVertical option applies to Original and Tangent modes. When this option is applied, the normal parameter from Draft.getNormal is ignored. X follows the curve tangent, Z is the VerticalVector property and Y is X.Cross(Z).

Version 18 cycle chain - Original mode

Align false
Align false

Railway cross ties (sleepers) - Tangent mode + ForceVertical

Align false
Align false

Frenet Mode

Align false
Align false